package com.eco.plugin.xxxx.webservicets.config;

import com.fr.config.*;
import com.fr.config.holder.Conf;
import com.fr.config.holder.factory.Holders;
import com.fr.intelli.record.Focus;
import com.fr.intelli.record.Original;
import com.fr.record.analyzer.EnableMetrics;

@Visualization(category = "代办配置")
@EnableMetrics
public class WinkSimpleConfig extends DefaultConfiguration {

    private static volatile WinkSimpleConfig config = null;

    @Focus(id="com.eco.plugin.xxxx.webservicets.config", text = "单点登录配置", source = Original.PLUGIN)
    public static WinkSimpleConfig getInstance() {
        if (config == null) {
            config = ConfigContext.getConfigInstance(WinkSimpleConfig.class);
        }
        return config;
    }

    @Identifier(value = "tempname", name = "模板名称", description = "模板名称", status = Status.SHOW)
    private Conf<String> tempname = Holders.simple("");

    @Identifier(value = "tburl", name = "填报地址", description = "填报地址", status = Status.SHOW)
    private Conf<String> tburl = Holders.simple("");

    @Identifier(value = "shurl", name = "审核地址", description = "审核地址", status = Status.SHOW)
    private Conf<String> shurl = Holders.simple("");

    @Identifier(value = "userWsdlUrl", name = "userWsdlUrl", description = "userWsdlUrl", status = Status.SHOW)
    private Conf<String> userWsdlUrl = Holders.simple("");

    @Identifier(value = "userNamespace", name = "userNamespace", description = "userNamespace", status = Status.SHOW)
    private Conf<String> userNamespace = Holders.simple("");

    @Identifier(value = "userMethod", name = "userMethod", description = "userMethod", status = Status.SHOW)
    private Conf<String> userMethod = Holders.simple("");

    @Identifier(value = "userKey", name = "userKey", description = "userKey", status = Status.SHOW)
    private Conf<String> userKey = Holders.simple("");

    @Identifier(value = "loginWsdlUrl", name = "loginWsdlUrl", description = "loginWsdlUrl", status = Status.SHOW)
    private Conf<String> loginWsdlUrl = Holders.simple("");

    @Identifier(value = "loginNamespace", name = "loginNamespace", description = "loginNamespace", status = Status.SHOW)
    private Conf<String> loginNamespace = Holders.simple("");

    @Identifier(value = "loginMethod", name = "loginMethod", description = "loginMethod", status = Status.SHOW)
    private Conf<String> loginMethod = Holders.simple("");

    @Identifier(value = "OAWsdlUrl", name = "OAWsdlUrl", description = "OAWsdlUrl", status = Status.SHOW)
    private Conf<String> OAWsdlUrl = Holders.simple("");

    @Identifier(value = "OANamespace", name = "OANamespace", description = "OANamespace", status = Status.SHOW)
    private Conf<String> OANamespace = Holders.simple("");

    @Identifier(value = "OAMethod", name = "OAMethod", description = "OAMethod", status = Status.SHOW)
    private Conf<String> OAMethod = Holders.simple("");

    public String getTempname() {
        return tempname.get();
    }

    public void setTempname(String url) {
        this.tempname.set(url);
    }

    public String getTburl() {
        return tburl.get();
    }

    public void setTburl(String url) {
        this.tburl.set(url);
    }

    public String getShurl() {
        return shurl.get();
    }

    public void setShurl(String url) {
        this.shurl.set(url);
    }

    public String getUserWsdlUrl() {
        return userWsdlUrl.get();
    }

    public void setUserWsdlUrl(String url) {
        this.userWsdlUrl.set(url);
    }

    public String getUserNamespace() {
        return userNamespace.get();
    }

    public void setUserNamespace(String url) {
        this.userNamespace.set(url);
    }

    public String getUserMethod() {
        return userMethod.get();
    }

    public void setUserMethod(String url) {
        this.userMethod.set(url);
    }

    public String getUserKey() {
        return userKey.get();
    }

    public void setUserKey(String url) {
        this.userKey.set(url);
    }

    public String getLoginWsdlUrl() {
        return loginWsdlUrl.get();
    }

    public void setLoginWsdlUrl(String url) {
        this.loginWsdlUrl.set(url);
    }

    public String getLoginNamespace() {
        return loginNamespace.get();
    }

    public void setLoginNamespace(String url) {
        this.loginNamespace.set(url);
    }

    public String getLoginMethod() {
        return loginMethod.get();
    }

    public void setLoginMethod(String url) {
        this.loginMethod.set(url);
    }

    public String getOAWsdlUrl() {
        return OAWsdlUrl.get();
    }

    public void setOAWsdlUrl(String url) {
        this.OAWsdlUrl.set(url);
    }

    public String getOANamespace() {
        return OANamespace.get();
    }

    public void setOANamespace(String url) {
        this.OANamespace.set(url);
    }

    public String getOAMethod() {
        return OAMethod.get();
    }

    public void setOAMethod(String url) {
        this.OAMethod.set(url);
    }

    @Override
    public Object clone() throws CloneNotSupportedException {
        WinkSimpleConfig cloned = (WinkSimpleConfig) super.clone();
//        cloned.text = (Conf<String>) text.clone();
//        cloned.count = (Conf<Integer>) count.clone();
//        cloned.price = (Conf<Double>) price.clone();
//        cloned.time = (Conf<Long>) time.clone();
//        cloned.student = (Conf<Boolean>) student.clone();
        return cloned;
    }

}
