package com.eco.plugin.xxxx.webservicets.dsdd.dsdd;

import com.eco.plugin.xxxx.webservicets.utils.FRUtils;
import com.eco.plugin.xxxx.webservicets.utils.WebServiceUtil;
import com.fr.base.TableData;
import com.fr.general.data.DataModel;
import com.fr.general.data.TableDataException;
import com.fr.schedule.base.bean.ScheduleTask;
import com.fr.schedule.base.controller.ScheduleTaskController;
import com.fr.schedule.feature.ScheduleContext;
import com.fr.schedule.feature.output.OutputActionHandler;
import com.fr.script.Calculator;
import com.fr.stable.query.QueryFactory;
import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import java.util.Map;

public class TsHandler extends OutputActionHandler<TsBean>{
    @Override
    public void doAction(TsBean tsBean, Map<String, Object> map) throws TableDataException {
        String type = tsBean.getType();
        String servername = tsBean.getServerdata();

        FRUtils.FRLogInfo("type:"+type+";servername:"+servername);

        Map<String,String> config = WebServiceUtil.getConfig(type);

        FRUtils.FRLogInfo("config:"+config.toString());

        TableData userInfo = FRUtils.getTableData(servername);
        DataModel userInfoDM = userInfo.createDataModel(Calculator.createCalculator());

        int fridindex = userInfoDM.getColumnIndex("FlowId");
        int receiverindex = userInfoDM.getColumnIndex("FlowNode1");
        int flowNode2Index = userInfoDM.getColumnIndex("FlowNode2");
        int FlowNameindex = userInfoDM.getColumnIndex("FlowName");

        int btindex = userInfoDM.getColumnIndex("bt");
        int ndindex = userInfoDM.getColumnIndex("nd");
        int yearindex = userInfoDM.getColumnIndex("year");
        int nfindex = userInfoDM.getColumnIndex("nf");
        int usernameindex = userInfoDM.getColumnIndex("fine_username");


        String name = config.get("name");
        String tburl = config.get("tburl");

        int rowcount = userInfoDM.getRowCount();

        for(int i=0;i<rowcount;i++){
            String receiver = String.valueOf(userInfoDM.getValueAt(i,receiverindex));
            String flownode2 = String.valueOf(userInfoDM.getValueAt(i,flowNode2Index));
            String flowid = String.valueOf(userInfoDM.getValueAt(i,fridindex));
            String flowName = String.valueOf(userInfoDM.getValueAt(i,FlowNameindex));

            String bt = URLEncoder.encode(String.valueOf(userInfoDM.getValueAt(i,btindex)));
            String nd = String.valueOf(userInfoDM.getValueAt(i,ndindex));
            String year = String.valueOf(userInfoDM.getValueAt(i,yearindex));
            String nf = String.valueOf(userInfoDM.getValueAt(i,nfindex));
            String username = String.valueOf(userInfoDM.getValueAt(i,usernameindex));


            String sysId = flowid+type;
            //流程id

            //发起待办
            String operater = "0";
            String publicParam = "&bt="+bt+"&nd="+nd+"&year="+year+"&nf="+nf+"&flowId="+flowid+"&node1="+receiver+"&node2="+flownode2+"&sysId="+sysId+"&projectid="+flowid+"&fine_username="+username;


            String tburl2 = tburl + publicParam ;

            WebServiceUtil.flowOperater(operater,sysId,tburl2,flowName+name,"节点1",receiver);
        }
    }

    /**
     * 获取定时调度
     * @param taskName
     * @return
     */
    private static ScheduleTask getTask(String taskName){
        ScheduleTask scheduleTask = null;
        try {
            ScheduleTaskController scheduleTaskController = ScheduleContext.getInstance().getScheduleTaskController();
            scheduleTask = scheduleTaskController.getByTaskName(taskName,QueryFactory.create());
        } catch (Exception e) {
            FRUtils.FRLogInfo("任务异常:"+e.getMessage());
            return null;
        }

        return scheduleTask;
    }

    /**
     * 获取模板链接
     * @param map
     * @return
     */
    private static String getTempUrl(TsBean tsBean,Map<String, Object> map){

        String taskName = String.valueOf(map.get("taskName"));

        ScheduleTask scheduleTask = getTask(taskName);

        int showType = scheduleTask.getShowType();
        String templateName = scheduleTask.getTemplatePath();
        try {
            templateName = URLEncoder.encode(templateName,"utf-8");
        } catch (UnsupportedEncodingException e) {
            FRUtils.FRLogInfo("编码模板名称异常:"+e.getMessage());
            return "";
        }

        if(1 == showType){
            templateName+="&op=write";
        }
        else if(2 == showType){
            templateName += "&op=view";
        }
        else if(3 == showType){
            templateName += "&op=write_plus";
        }

        return tsBean.getResultURL()+"/view/report?viewlet="+templateName;
    }

    /**
     * 获取用户组信息
     * @param map
     * @return
     */
    private static String[] getUserGroup(Map<String, Object> map){
        String taskName = String.valueOf(map.get("taskName"));
        ScheduleTask scheduleTask = getTask(taskName);

        return scheduleTask.getUserGroup().createUserNameArray();
    }

}
