package com.eco.plugin.xxxx.webservicets.handler;

import com.eco.plugin.xxxx.webservicets.bean.EmployFLOW;
import com.eco.plugin.xxxx.webservicets.utils.FRUtils;
import com.eco.plugin.xxxx.webservicets.utils.ResponseUtils;
import com.eco.plugin.xxxx.webservicets.utils.WebServiceUtil;
import com.fr.base.TableData;
import com.fr.decision.fun.impl.BaseHttpHandler;
import com.fr.general.data.DataModel;
import com.fr.general.data.TableDataException;
import com.fr.script.Calculator;
import com.fr.third.springframework.web.bind.annotation.RequestMethod;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.net.URLEncoder;
import java.util.HashMap;
import java.util.Map;

public class FlowHandler extends BaseHttpHandler {
    public FlowHandler() {
    }

    @Override
    public RequestMethod getMethod() {
        return RequestMethod.GET;
    }

    @Override
    public String getPath() {
        return "/operateFlow";
    }

    @Override
    public boolean isPublic() {
        return true;
    }

    @Override
    public void handle(HttpServletRequest req, HttpServletResponse res) throws Exception {

        String operation = req.getParameter("operation");
        String url = req.getParameter("url");
        String type = req.getParameter("type");
        String servername = req.getParameter("serverdataname");

        Map<String,String> paramMap = this.getParamMap(url);
        String flowId = paramMap.get("flowId");
        String sysId = flowId+type;
        String approveId = flowId+type+"sh";

        EmployFLOW ef = getEmployFlowByFlowId(flowId,servername);

        String node1 = ef.getFlowNode1();
        String node2 = ef.getFlowNode2();

        String publicParam = "&flowId="+flowId+"&node1="+node1+"&node2="+node2;

        Map<String,String> config = WebServiceUtil.getConfig(type);

        String workFlowName = config.get("name");
        String pcUrl = config.get("tburl") +publicParam;;
        String shUrl = config.get("shurl") +publicParam;;

        workFlowName = ef.getFlowName() + workFlowName;


        if(operation==null || operation.isEmpty()){
            ResponseUtils.failedResponse(res,"operation不能为空");
            return ;
        }


        if(sysId == null || sysId.isEmpty() || node1==null || node1.isEmpty()|| flowId==null || flowId.isEmpty()){
            ResponseUtils.failedResponse(res,"sysId,node1,flowId不能为空");
            return ;
        }

        if("1".equals(operation)){
            endFlow(sysId,node1,workFlowName);

            shUrl+="&SBNF="+ef.getSBNF()+"&SBLX="+ef.getSBLX()+"&bt="+ URLEncoder.encode(ef.getBt())+"&nd="+ef.getNd()+"&year="+ef.getYear()+"&nf="+ef.getNf()+"&projectid="+flowId+"&fine_role="+ef.getRole();
            startFlow(approveId,node2,workFlowName+"审核",shUrl);

            FRUtils.FRLogInfo("完成填报,sysId:"+sysId+";approveId="+approveId);
        }else if("2".equals(operation)){
            endFlow(approveId,node2,workFlowName+"退回");

            startFlow(sysId,node1,workFlowName+"被退回",pcUrl+"&sysId="+sysId);

            FRUtils.FRLogInfo("退回:sysId->"+sysId+";approveId->"+approveId);

        }else{
            endFlow(approveId,node2,workFlowName+"结束");
        }
    }

    private void startFlow(String approvId,String aprrovName,String workFlowName,String redirectUrl){
         WebServiceUtil.flowOperater("0",approvId,redirectUrl,workFlowName,"待办",aprrovName);
    }

    private void endFlow(String sysId,String userName,String workFLowName){
         WebServiceUtil.flowOperater("2",sysId,"",workFLowName,"完成",userName);
    }

    private Map<String,String> getParamMap(String url){
        Map<String,String> resultMap = new HashMap<String,String>();
        String[] urls = url.split("\\?");
        String[] param = urls[1].split("&");

        for(String item : param){
            String[] paramItem = item.split("=");
            resultMap.put(paramItem[0],paramItem[1]);
        }

        return resultMap;
    }

    private EmployFLOW getEmployFlowByFlowId(String flowId, String servername) throws TableDataException {
        TableData tableData = FRUtils.getTableData(servername);
        DataModel userInfoDM = tableData.createDataModel(Calculator.createCalculator());

        int flowIdindex = userInfoDM.getColumnIndex("FlowId");
        int flowNode1index = userInfoDM.getColumnIndex("FlowNode1");
        int flowNode2index = userInfoDM.getColumnIndex("FlowNode2");
        int flowNameindex = userInfoDM.getColumnIndex("FlowName");
        int SBLXindex = userInfoDM.getColumnIndex("SBLX");
        int SBNFindex = userInfoDM.getColumnIndex("SBNF");

        int btindex = userInfoDM.getColumnIndex("bt");
        int ndindex = userInfoDM.getColumnIndex("nd");
        int yearindex = userInfoDM.getColumnIndex("year");
        int nfindex = userInfoDM.getColumnIndex("nf");
        int roleIndex = userInfoDM.getColumnIndex("fine_role");

        EmployFLOW ef = new EmployFLOW();

        for(int i =0;i<userInfoDM.getRowCount();i++){
            String flowid = String.valueOf(userInfoDM.getValueAt(i,flowIdindex));
            if(flowid.equals(flowId)){
                String bt = String.valueOf(userInfoDM.getValueAt(i,btindex));
                String nd = String.valueOf(userInfoDM.getValueAt(i,ndindex));
                String year = String.valueOf(userInfoDM.getValueAt(i,yearindex));
                String nf = String.valueOf(userInfoDM.getValueAt(i,nfindex));
                String role = String.valueOf(userInfoDM.getValueAt(i,roleIndex));

                ef.setFlowNode1(String.valueOf(userInfoDM.getValueAt(i,flowNode1index)));
                ef.setFlowNode2(String.valueOf(userInfoDM.getValueAt(i,flowNode2index)));
                ef.setFlowName(String.valueOf(userInfoDM.getValueAt(i,flowNameindex)));
                ef.setSBLX(String.valueOf(userInfoDM.getValueAt(i,SBLXindex)));
                ef.setSBNF(String.valueOf(userInfoDM.getValueAt(i,SBNFindex)));
                ef.setBt(bt);
                ef.setNd(nd);
                ef.setYear(year);
                ef.setNf(nf);
                ef.setRole(role);
                break;
            }

        }

        return ef;
    }


}

