package com.eco.plugin.xxxx.webservicets.utils;

import com.eco.plugin.xxxx.webservicets.config.WinkSimpleConfig;
import org.apache.axis.client.Call;
import org.apache.axis.client.Service;
import org.w3c.dom.NodeList;
import javax.xml.namespace.QName;
import javax.xml.rpc.ParameterMode;
import javax.xml.rpc.encoding.XMLType;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;


public class WebServiceUtil {

    /**
     * 根据用户名获取用户Id
     *
     * @param userName
     * @return
     */
    public static String getUserId(String userName) {
        WinkSimpleConfig psc =WinkSimpleConfig.getInstance();

        String userKey = psc.getUserKey();
        String userNamespace = psc.getUserNamespace();
        String userMethod = psc.getUserMethod();
        String userWsdlUrl = psc.getUserWsdlUrl();

        String userId = "";

        Service service = new Service();
        Call call;
        try {
            Object[] object = new Object[2];

            object[0] = userName;
            object[1] = userKey;
            call = (Call) service.createCall();
            QName opAddEntry = new QName(userNamespace, userMethod); //设置命名空间和需要调用的方法名
            call.setTargetEndpointAddress(userWsdlUrl); //设置请求路径
            call.setOperationName(userMethod); //调用的方法名
            call.setTimeout(Integer.valueOf(2000));        //设置请求超时
            call.setReturnType(org.apache.axis.encoding.XMLType.XSD_STRING);//设置返回类型
            call.addParameter("Uid", XMLType.XSD_STRING, ParameterMode.IN);
            call.addParameter("key", XMLType.XSD_STRING, ParameterMode.IN);

            userId = (String) call.invoke(opAddEntry, object);

            if("-1".equals(userId)){
                userId="";
            }
        } catch (Exception e) {
            FRUtils.FRLogError("getUserId exception->"+e.getMessage());
        }

        return userId;
    }

    //验证token
    public static boolean validate(String token, String userId) {
        WinkSimpleConfig psc =WinkSimpleConfig.getInstance();

        boolean flag = false;
        String loginWsdlUrl=psc.getLoginWsdlUrl();
        String loginNamespace=psc.getLoginNamespace();
        String loginMethod=psc.getLoginMethod();

        Service service = new Service();
        Call call;
        try {
            Object[] object = new Object[2];

            object[0] = token;
            object[1] = userId;
            call = (Call) service.createCall();
            QName opAddEntry = new QName(loginNamespace, loginMethod); //设置命名空间和需要调用的方法名
            call.setTargetEndpointAddress(loginWsdlUrl); //设置请求路径
            call.setOperationName(loginMethod); //调用的方法名
            call.setTimeout(Integer.valueOf(2000));        //设置请求超时
            call.setReturnType(org.apache.axis.encoding.XMLType.XSD_STRING);//设置返回类型
            call.addParameter("Token", XMLType.XSD_STRING, ParameterMode.IN);
            call.addParameter("User", XMLType.XSD_STRING, ParameterMode.IN);

            String result = (String) call.invoke(opAddEntry, object);

            NodeList nodeList = XMLUtils.xmlTONodeList(result);
            String returnCode = XMLUtils.getValueByNodeName(nodeList,"returnCode");

            if("0".equals(returnCode)){
                flag=true;
            }
        } catch (Exception e) {
            FRUtils.FRLogError("validate exception ->"+e.getMessage());
        }

        return flag;
    }

    /**
     * 流程操作
     *
     * @param operater 1、发起填报待办  2、完成填报待办 3、发起审核待办 4、完结审核待办
     * @param flowid 流程id
     * @param pcUrl 审核url
     * @param workFLowName 流程名称
     * @param nodeName 节点名称
     * @param receiver 流程接收人
     * @return
     */
    public static void flowOperater(String operater,String flowid,String pcUrl,String workFLowName,String nodeName,String receiver) {
        WinkSimpleConfig psc =WinkSimpleConfig.getInstance();

        String OANamespace =psc.getOANamespace();
        String OAMethod = psc.getOAMethod();
        String OAWsdlUrl = psc.getOAWsdlUrl();

        String receivedatetime = DateUtilSelf.DateToString(new Date(),"yyyy-MM-dd HH:mm:ss");

        Service service = new Service();
        Call call;
        String result = "";

        try {
            Object[] object = new Object[1];
            object[0] = "{\n" +
                    "\t\"syscode\":\"BI\",\n" +
                    "\t\"flowid\":\""+ flowid +"\",\n" +
                    "\t\"requestname\":\"" + workFLowName + "\",\n" +
                    "\t\"workflowname\":\"" + workFLowName + "\",\n" +
                    "\t\"nodename\":\"" + nodeName + "\",\n" +
                    "\t\"pcurl\":\""+ pcUrl +"\",\n" +
                    "\t\"appurl\":\"\",\n" +
                    "\t\"creator\":\"admin\",\n" +
                    "\t\"createdatetime\":\"" + receivedatetime + "\",\n" +
                    "\t\"receiver\":\""+ receiver +"\",\n" +
                    "\t\"receivedatetime\":\""+ receivedatetime +"\",\n" +
                    "\t\"isremark\":\""+ operater +"\",\n" +
                    "\t\"viewtype\":\"0\",\n" +
                    "\t\"receivets\":\"\"\n" +
                    "}";//Object是用来存储方法的参数
            //{"errCode":0,"data":"{\"message\":\"流程数据【测试流程001】自动更新办结成功\",\"dataType\":\"WfData\",\"operResult\":\"1\",\"syscode\":\"BI\",\"operType\":\"AutoEdit\"}"}

            call = (Call) service.createCall();
            QName opAddEntry = new QName(OANamespace, OAMethod); //设置命名空间和需要调用的方法名
            call.setTargetEndpointAddress(OAWsdlUrl); //设置请求路径
            call.setOperationName(OAMethod); //调用的方法名
            call.setTimeout(Integer.valueOf(2000));        //设置请求超时
            call.setReturnType(org.apache.axis.encoding.XMLType.XSD_STRING);//设置返回类型
            call.addParameter("dataMap", XMLType.SOAP_ARRAY, ParameterMode.IN);

            result = (String) call.invoke(opAddEntry, object);
            FRUtils.FRLogInfo("flowOperater result ->"+result);
        } catch (Exception e) {
            FRUtils.FRLogError("flowOperater exception ->"+e.getMessage());
        }
    }

    public static Map<String,String> getConfig(String type){
        WinkSimpleConfig psc = WinkSimpleConfig.getInstance();
        String tburl = psc.getTburl();
        String shurl = psc.getShurl();
        String tempname = psc.getTempname();

        Map<String,String> map = new HashMap<String,String>();
        map.put("name",getValue(tempname,type));
        map.put("tburl",getValue(tburl,type));
        map.put("shurl",getValue(shurl,type));

        return map;
    }

    public static void main(String[] args) {
        String tburl = "pttx,http://bi.ibtcloud.cn/decision/view/report?viewlet=Buletown_INFO%252F%25E5%25B9%25B3%25E5%258F%25B0%25E4%25BF%25A1%25E6%2581%25AF_%25E7%25A1%25AE%25E8%25AE%25A4.cpt&ref_t=design&op=write&ref_c=ecc6e216-cf3f-4421-bad5-b652cc8f781b";
        String type = "pttx";
        System.out.println(getValue(tburl,type));

    }


    /**
     * 根据key获取值
     * @param url
     * @param type
     * @return
     */
    private static String getValue(String url,String type){
        String result = "";
        String[] keyvalue = url.split(";");

        for(int i=0;i<keyvalue.length;i++){
            String kv = keyvalue[i];
            String[] kvs = kv.split(",");
            String key = kvs[0];
            String value = kvs[1];

            if(key.equals(type)){
                result = value;
                break;
            }
        }

        return result;
    }
}
